capture program drop mle_within
program define mle_within
     version 10.1
     args todo b lnf
     tempvar  xb zd epsi lf_i last id time
     tempname lambda explambda
     tempname sigma expsigma
     tempname epsi_m epsi_dm

     mleval `xb'  = `b', eq(1)
     mleval `lambda' = `b', eq(2) scalar
     mleval `sigma' = `b', eq(3) scalar

     scalar `explambda' = exp(`lambda')
     scalar `expsigma' = exp(`sigma')

*****************************************************
     quie gen double `id' = $cham_pi
     quie gen double `time' = $cham_pt
*****************************************************

     sort `id' `time'

     quie gen double `epsi'=$ML_y1 - `xb'

     bysort `id': egen double `epsi_m' = mean(`epsi')
     quie gen double `epsi_dm' = `epsi' - `epsi_m'

     sort `id' `time'

     panel_within,  epsi_m(`epsi_dm') explambda(`explambda') expsigma(`expsigma')  id(`id')

     svmat ln_g, names(lng)

     gen double `lf_i' = lng1

     capture drop lng1

     sort `id' `time'

     quie by `id': gen double `last'=1 if ( _n==_N)

     mlsum `lnf'= `lf_i' if `last' == 1

end
